#include <stdio.h>
#include <string.h>
#define MAXLEN 1000 /*       */
#define MAXLINES 5000 /*   ,
     */
#define ALLOCSIZE 10000 /*     */
static char allocbuf[ALLOCSIZE]; /*   alloc */
static char *allocp = allocbuf; /*    */
int getline(char *, int);
char *alloc(int);
char *lineptr[MAXLINES]; /*     */
int readlines(char *lineptr[], int nlines);
void writelines(char *lineptr[], int nlines);
void qsort(char *lineptr[], int left, int right);

/*    */
int mainSort() {
	int nlines; /*      */
	if ((nlines = readlines(lineptr, MAXLINES)) >= 0) {
		qsort(lineptr, 0, nlines - 1);
		writelines(lineptr, nlines);
		return 0;
	} else {
		printf("error: input too big to sort\n");
		return 1;
	}
}
/* getline:    s,    */
int getline(char s[], int lim) {
	int c, i;
	i = 0;
	while (--lim > 0 && (c = getchar()) != EOF && c != '\n')
		s[i++] = c;
	if (c == '\n')
		s[i++] = c;
	s[i] = '\0';
	return i;
}

/* readlines:     */
int readlines(char *lineptr[], int maxlines) {
	int len, nlines;
	char *p, line[MAXLEN];
	nlines = 0;
	while ((len = getline(line, MAXLEN)) > 0)
		if (nlines >= maxlines || (p = alloc(len)) == NULL)
			return -1;
		else {
			line[len - 1] = '\0'; /*    */
			strcpy(p, line);
			lineptr[nlines++] = p;
		}
	return nlines;
}
/* writelines:     */
void writelines(char *lineptr[], int nlines) {
	while (nlines-- > 0)
		printf("%s\n", *lineptr++);
}
/* qsort:  v[left]...v[right]    */
void qsort(char *v[], int left, int right) {
	int i, last;
	void swap(char *v[], int i, int j);
	if (left >= right) /*   ,    */
		return; /* -    */
	swap(v, left, (left + right) / 2);
	last = left;
	for (i = left + 1; i <= right; i++)
		if (strcmp (v[i], v[left]) < 0)
			swap(v, ++last, i);
	swap(v, left, last);
	qsort(v, left, last - 1);
	qsort(v, last + 1, right);
}
/* swap:  v[i]  v[j] */
void swap(char *v[], int i, int j) {
	char *temp;
	temp = v[i];
	v[i] = v[j];
	v[j] = temp;
}
char *alloc(int n) /*    n  */
{
	if (allocbuf + ALLOCSIZE - allocp >= n) { /*   */
		allocp += n;
		return allocp - n; /*    p */
	} else
		/*    */
		return 0;
}

void afree(char *p) /*  ,     */
{
	if (p >= allocbuf && p < allocbuf + ALLOCSIZE)
		allocp = p;
}
